## pandoc 2.9.2.1

=== Makefile ===
version?=$(shell grep '^[Vv]ersion:' pandoc.cabal | awk '{print $$2;}')
pandoc=$(shell find dist -name pandoc -type f -exec ls -t {} \; | head -1)
SOURCEFILES?=$(shell git ls-tree -r master --name-only | grep "\.hs$$")
BRANCH?=master
RESOLVER?=lts-13
GHCOPTS=-fdiagnostics-color=always
WEBSITE=../../web/pandoc.org

quick:
	stack install --ghc-options='$(GHCOPTS)' --install-ghc --flag 'pandoc:embed_data_files' --fast --test --ghc-options='-j +RTS -A64m -RTS' --test-arguments='-j4 --hide-successes $(TESTARGS)'

quick-cabal:
	cabal new-configure . --ghc-options '$(GHCOPTS)' --disable-optimization --enable-tests
	cabal new-build . --disable-optimization
	cabal new-run test-pandoc --disable-optimization -- --hide-successes $(TESTARGS)

full-cabal:
	cabal new-configure . --ghc-options '$(GHCOPTS)' --flags '+embed_data_files +trypandoc' --enable-tests --enable-benchmarks
	cabal new-build . --disable-optimization
	cabal new-run test-pandoc --disable-optimization -- --hide-successes $(TESTARGS)

full:
	stack install --flag 'pandoc:embed_data_files' --flag 'pandoc:trypandoc' --bench --no-run-benchmarks --test --test-arguments='-j4 --hide-successes' --ghc-options '-Wall -Werror -fno-warn-unused-do-bind -O0 -j4 $(GHCOPTS)'

ghci:
	stack ghci --flag 'pandoc:embed_data_files'

haddock:
	stack haddock

# Note:  to accept current results of golden tests,
# make test TESTARGS='--accept'
test:
	stack test --flag 'pandoc:embed_data_files' --fast --test-arguments='-j4 --hide-successes $(TESTARGS)' --ghc-options '$(GHCOPTS)'

ghcid:
	ghcid -c "stack repl --flag 'pandoc:embed_data_files'"

bench:
	stack bench --benchmark-arguments='$(BENCHARGS)' --ghc-options '$(GHCOPTS)'

weigh:
	stack build --ghc-options '$(GHCOPTS)' pandoc:weigh-pandoc && stack exec weigh-pandoc

reformat:
	for f in $(SOURCEFILES); do echo $$f; stylish-haskell -i $$f ; done

lint: hlint fix_spacing

hlint:
	for f in $(SOURCEFILES); do echo $$f; hlint --verbose --refactor --refactor-options='-s -o -' $$f; done

fix_spacing:
	# Fix trailing newlines and spaces at ends of lines
	for f in $(SOURCEFILES); do printf '%s\n' "`cat $$f`" | sed -e 's/  *$$//' > $$f.tmp; mv $$f.tmp $$f; done

changes_github:
	pandoc --filter tools/extract-changes.hs changelog.md -t gfm --wrap=none --template tools/changes_template.html | sed -e 's/\\#/#/g' | pbcopy

dist: man/pandoc.1
	cabal sdist
	rm -rf "pandoc-${version}"
	tar xvzf dist/pandoc-${version}.tar.gz
	cd pandoc-${version}
	stack setup && stack test && cd .. && rm -rf "pandoc-${version}"

packages: checkdocs winpkg debpkg macospkg

checkdocs: README.md
	! grep -n -e "\t" MANUAL.txt changelog

debpkg: man/pandoc.1
	make -C linux && \
	cp linux/artifacts/pandoc-$(version)-*.* .

macospkg: man/pandoc.1
	./macos/make_macos_package.sh

winpkg: pandoc-$(version)-windows-i386.msi pandoc-$(version)-windows-i386.zip pandoc-$(version)-windows-x86_64.msi pandoc-$(version)-windows-x86_64.zip

pandoc-$(version)-windows-%.zip: pandoc-$(version)-windows-%.msi
	ORIGDIR=`pwd` && \
	CONTAINER=$(basename $<) && \
	TEMPDIR=`mktemp -d` && \
	msiextract -C $$TEMPDIR/msi $< && \
	pushd $$TEMPDIR && \
	mkdir $$CONTAINER && \
	find msi -type f -exec cp {} $$CONTAINER/ \; && \
	zip -r $$ORIGDIR/$@ $$CONTAINER && \
	popd & \
	rm -rf $$TEMPDIR

pandoc-$(version)-windows-%.msi: pandoc-windows-%.msi
	osslsigncode sign -pkcs12 ~/Private/SectigoCodeSigning.exp2023.p12 -in $< -i http://johnmacfarlane.net/ -t http://timestamp.comodoca.com/ -out $@ -askpass
	rm $<

.INTERMEDIATE: pandoc-windows-i386.msi pandoc-windows-x86_64.msi

pandoc-windows-i386.msi:
	JOBID=$(shell curl https://ci.appveyor.com/api/projects/jgm/pandoc | jq '.build.jobs[]| select(.name|test("i386")) | .jobId') && \
	wget "https://ci.appveyor.com/api/buildjobs/$$JOBID/artifacts/windows%2F$@" -O $@

pandoc-windows-x86_64.msi:
	JOBID=$(shell curl https://ci.appveyor.com/api/projects/jgm/pandoc | jq '.build.jobs[]| select(.name|test("x86_64")) | .jobId') && \
	wget "https://ci.appveyor.com/api/buildjobs/$$JOBID/artifacts/windows%2F$@" -O $@

man/pandoc.1: MANUAL.txt man/pandoc.1.before man/pandoc.1.after
	pandoc $< -f markdown-smart -t man -s \
		--lua-filter man/manfilter.lua \
		--include-before-body man/pandoc.1.before \
		--include-after-body man/pandoc.1.after \
		--metadata author="" \
		--variable footer="pandoc $(version)" \
		-o $@

README.md: README.template MANUAL.txt tools/update-readme.lua
	pandoc --lua-filter tools/update-readme.lua --reference-links \
	      --reference-location=section -t gfm $< -o $@

download_stats:
	curl https://api.github.com/repos/jgm/pandoc/releases | \
		jq -r '.[] | .assets | .[] | "\(.download_count)\t\(.name)"'

pandoc-templates:
	rm ../pandoc-templates/default.* ; \
	cp data/templates/default.* README.md styles.* ../pandoc-templates/ ; \
	pushd ../pandoc-templates/ && \
	git add default.* README.md styles.* && \
	git commit -m "Updated templates for pandoc $(version)" && \
	popd

trypandoc:
	ssh -t macfarlane 'cd src/pandoc && git pull && stack install --flag pandoc:trypandoc --flag pandoc:embed_data_files && cd trypandoc && sudo make install'

update-website:
	make -C $(WEBSITE) update
	make -C $(WEBSITE)
	make -C $(WEBSITE) upload

clean:
	stack clean

.PHONY: deps quick full haddock install clean test bench changes_github macospkg dist prof download_stats reformat lint weigh doc/lua-filters.md packages pandoc-templates trypandoc update-website debpkg macospkg winpkg checkdocs ghcid ghci fix_spacing hlint

=== linux/Makefile ===
TREE?=HEAD
ARTIFACTS=`pwd`/artifacts
REVISION?=1

build:
	mkdir -p $(ARTIFACTS)
	docker build -t alpine-pandoc .
	docker run --env TREE=$(TREE) --env REVISION=$(REVISION) \
	    -v $(ARTIFACTS):/artifacts alpine-pandoc

interact:
	docker run --env TREE=$(TREE) --env REVISION=$(REVISION) \
		-v $(ARTIFACTS):/artifacts -it alpine-pandoc bash

setup:
	docker pull alpine:edge

.PHONY: build setup interact

=== macos/Makefile ===
VERSION=$(shell cat version.txt)
BASE=pandoc-$(VERSION)
DEST=pandoc/usr/local
ALL=$(BASE)-macOS.pkg $(BASE)-macOS.zip

all: $(ALL) notarize

signed.txt: $(DEST)
	chmod +x $(DEST)/bin/pandoc $(DEST)/bin/pandoc-citeproc
	codesign --force --options runtime -s "5U2WKE6DES" $(DEST)/bin/pandoc
	codesign --force --options runtime -s "5U2WKE6DES" $(DEST)/bin/pandoc-citeproc
	echo "SIGNED" > signed.txt

pandoc.pkg: signed.txt
	pkgbuild --root pandoc --identifier net.johnmacfarlane.pandoc --version $(VERSION) --ownership recommended $@

$(BASE)-macOS.pkg: pandoc.pkg
	productbuild --distribution distribution.xml --resources Resources --package-path $< --version $(VERSION) --sign 'Developer ID Installer: John Macfarlane' $@

$(BASE)-macOS.zip: signed.txt
	ln -s $(DEST) $(BASE)
	zip -r $@ $(BASE)

gon.hcl: version.txt
	echo "notarize {\n  path = \"$(BASE)-macOS.pkg\"\n  bundle_id = \"org.pandoc.pandoc\"\n  staple = true\n}\napple_id {\n  username = \"jgm@berkeley.edu\"\n  password = \"@env:AC_PASSWORD\"\n}" > $@

notarize: gon.hcl $(BASE)-macOS.pkg
	gon -log-level=warn ./gon.hcl

clean:
	rm signed.txt $(BASE) pandoc.pkg gon.hcl

distclean: clean
	rm $(ALL)

.PHONY: all clean distclean

=== windows/Makefile ===
UNSIGNED=$(wildcard pandoc-*-UNSIGNED.msi)
SIGNED=$(patsubst %-UNSIGNED.msi, %.msi, $(UNSIGNED))

all: $(SIGNED)

.PHONY: all

pandoc-%.msi: pandoc-%-UNSIGNED.msi
	osslsigncode sign -pkcs12 $$HOME/Private/SectigoCodeSigning.exp2023.p12 -in $< -i http://johnmacfarlane.net/ -t http://timestamp.comodoca.com/ -out $@ -askpass && rm $<

=== debian/changelog ===
pandoc (2.9.2.1-3ubuntu2) jammy; urgency=medium

  * No-change rebuild against libcmark-gfm0.29.0.gfm.3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 21 Mar 2022 00:05:24 +0000

pandoc (2.9.2.1-3ubuntu1) jammy; urgency=medium

  * Merge with Debian unstable (LP: #1959576). Remaining changes:
    - d/rules: Disable optimization on riscv.
    - d/rules: add arm64 back to the list of low memory builds.

 -- Utkarsh Gupta <utkarsh@ubuntu.com>  Mon, 31 Jan 2022 19:04:12 +0530

pandoc (2.9.2.1-3) unstable; urgency=medium

  * simple rebuild to link against current libcmark
    (see bug#1003964)

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 19 Jan 2022 09:58:08 +0100

pandoc (2.9.2.1-2) unstable; urgency=medium

  * fix modernize path to katex;
    build-depend on libjs-katex (not node-katex)
  * declare compliance with Debian Policy 4.6.0
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 13 Jan 2022 21:19:10 +0100

pandoc (2.9.2.1-1ubuntu4) impish; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Sep 2021 07:01:41 +0200

pandoc (2.9.2.1-1ubuntu3) hirsute; urgency=medium

  * No-change rebuild for new GHC ABIs

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Oct 2020 20:58:42 +0000

pandoc (2.9.2.1-1ubuntu2) groovy; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 06 Sep 2020 09:16:48 +0200

pandoc (2.9.2.1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/rules: Disable optimization on riscv.
    - debian/rules: add arm64 back to the list of low memory builds

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 29 Aug 2020 16:26:15 -0700

pandoc (2.9.2.1-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update package relations:
    + tighten GHC lower bounds
      for doclayout jira-wiki-markup skylighting
      skylighting-core texmath
    + relax GHC upper bounds
      for doclayout jira-wiki-markup
    Closes: bug#968882, thanks to Adrian Bunk
  * update long descriptions: add new reader CSV
  * unfuzz patches
  * copyright: update coverage
  * add patch cherry-picked upstream
    to revert dependency on base-noprelude
  * fix stop annotate Multi-Arch: same
    for libghc-pandoc-dev libghc-pandoc-prof

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 23 Aug 2020 10:24:33 +0200

pandoc (2.9.1.1-3ubuntu4) groovy; urgency=medium

  * Rebuild against new GHC ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Aug 2020 23:45:54 +0200

pandoc (2.9.1.1-3ubuntu3) groovy; urgency=medium

  * Really apply the change from the previous entry

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 05 Aug 2020 16:38:10 +0200

pandoc (2.9.1.1-3ubuntu2) groovy; urgency=medium

  * debian/rules: add arm back to the list of low memory builds

 -- Sebastien Bacher <seb128@ubuntu.com>  Wed, 05 Aug 2020 13:43:27 +0200

pandoc (2.9.1.1-3ubuntu1) groovy; urgency=medium

  * Resynchronize on Debian, remaining changes
  * debian/rules:
    - Disable optimization on riscv.

 -- Sebastien Bacher <seb128@debian.org>  Tue, 04 Aug 2020 17:10:56 +0200

pandoc (2.9.1.1-3) unstable; urgency=medium

  * tune build for weak targets:
    + revert to C option ggc-min-expand=10
    + include hppa as a weak target
    + add C option -O0
    really closes: bug#965121, thanks (also) to Adrian Bunk

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 30 Jul 2020 15:31:00 +0200

pandoc (2.9.1.1-2) unstable; urgency=medium

  * reduce compile-time memory utilization on armel and armhf
    (in addition to mips and mipsel),
    and reduce further
    (begin garbage-collect at 5% memory utilization not 10%);
    closes: bug#965121, thanks to Sebastian Ramacher

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 16 Jul 2020 17:13:21 +0200

pandoc (2.9.1.1-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * fix provide virtual pandoc-abi-*
  * annotate binary package pandoc-dev as Multi-Arch: same
  * drop patch cherry-picked upstream since applied
  * copyright: update coverage
  * update long descriptions:
    + add new reader: Kira markup
  * fix provide virtual pandoc-abi

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Jul 2020 12:44:35 +0200

pandoc (2.8.1-2) unstable; urgency=medium

  * fix typo in previous changelog entry
  * declare compliance with Debian Policy 4.5.0
  * mention citation-style-language-styles in README.Debian
    (not only in long description)
  * fix update -doc build-dependencies
  * annotate binary package pandoc-doc as Multi-Arch: foreign;
    annotate binary package pandoc-prof as Multi-Arch: same
  * drop NEWS older than oldstable

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 14 Jul 2020 11:29:37 +0200

pandoc (2.8.1-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)
    closes: bug#927689, #964822, #959851

  [ Jonas Smedegaard ]
  * fix typo in previous changelog entry
  * suggest citation-style-language-styles;
    mention when suitable to use
    in long description of binary package pandoc
  * provide virtual package pandoc-abi,
    versioned based on pandoc-types upstream version;
    see bug#962715
  * drop patches cherry-picked upstream since applied
  * unfuzz and update patches
  * update package relations:
    + add GHC for attoparsec doclayout hslua-module-system
      skylighting-core text-conversions
    + tighten GHC lower bounds
      for cmark-gfm haddock-library hsyaml pandoc-types
      skylighting texmath
    + relax GHC upper bounds
      for diff cmark-gfm glob haddock-library hsyaml http-client
      pandoc-types quickcheck2 skylighting texmath
  * update long descriptions:
    + add new readers: DokuWiki markup, ipynb (Jupyter notebooks)
    + add new writers: XWiki, Jira, ipynb
  * copyright: update coverage



=== debian/control ===
Source: pandoc
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Haskell Group <debian-haskell@lists.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
 , Kiwamu Okabe <kiwamu@debian.or.jp>
 , Clint Adams <clint@debian.org>
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 ghc,
 ghc-prof,
 alex,
 happy,
 libghc-aeson-dev (<< 1.5),
 libghc-aeson-prof,
 libghc-aeson-pretty-dev (>= 0.8.5),
 libghc-aeson-pretty-dev (<< 0.9),
 libghc-aeson-pretty-prof,
 libghc-attoparsec-dev (<< 0.14),
 libghc-attoparsec-prof,
 libghc-base64-bytestring-dev (<< 1.1),
 libghc-base64-bytestring-prof,
 libghc-blaze-html-dev (>= 0.9),
 libghc-blaze-html-dev (<< 0.10),
 libghc-blaze-html-prof,
 libghc-blaze-markup-dev (>= 0.8),
 libghc-blaze-markup-dev (<< 0.9),
 libghc-blaze-markup-prof,
 libghc-case-insensitive-dev (>= 1.2),
 libghc-case-insensitive-dev (<< 1.3),
 libghc-case-insensitive-prof,
 libghc-cmark-gfm-dev (>= 0.2),
 libghc-cmark-gfm-dev (<< 0.3),
 libghc-cmark-gfm-prof,
 libghc-data-default-dev (<< 0.8),
 libghc-data-default-prof,
 libghc-doclayout-dev (>= 0.3),
 libghc-doclayout-dev (<< 0.4),
 libghc-doclayout-prof,
 libghc-doctemplates-dev (>= 0.8),
 libghc-doctemplates-dev (<< 0.9),
 libghc-doctemplates-prof,
 libghc-emojis-dev (<< 0.2),
 libghc-emojis-prof,
 libghc-exceptions-dev (>= 0.8),
 libghc-exceptions-dev (<< 0.11),
 libghc-exceptions-prof,
 libghc-glob-dev (<< 0.11),
 libghc-glob-prof,
 libghc-haddock-library-dev (>= 1.8),
 libghc-haddock-library-dev (<< 1.9),
 libghc-haddock-library-prof,
 libghc-hslua-dev (>= 1.0.1),
 libghc-hslua-dev (<< 1.1),
 libghc-hslua-prof,
 libghc-hslua-module-system-dev (>= 0.2),
 libghc-hslua-module-system-dev (<< 0.3),
 libghc-hslua-module-system-prof,
 libghc-hslua-module-text-dev (>= 0.2),
 libghc-hslua-module-text-dev (<< 0.3),
 libghc-hslua-module-text-prof,
 libghc-hsyaml-dev (>= 0.2),
 libghc-hsyaml-dev (<< 0.3),
 libghc-hsyaml-prof,
 libghc-http-dev (<< 1:4000.4),
 libghc-http-prof,
 libghc-http-client-dev (>= 0.4.30),
 libghc-http-client-dev (<< 0.7),
 libghc-http-client-prof,
 libghc-http-client-tls-dev (>= 0.2.4),
 libghc-http-client-tls-dev (<< 0.4),
 libghc-http-client-tls-prof,
 libghc-http-types-dev (<< 0.13),
 libghc-http-types-prof,
 libghc-ipynb-dev (<< 0.2),
 libghc-ipynb-prof,
 libghc-jira-wiki-markup-dev (>= 1.1),
 libghc-jira-wiki-markup-dev (<< 1.2),
 libghc-jira-wiki-markup-prof,
 libghc-juicypixels-dev (<< 3.4),
 libghc-juicypixels-prof,
 libghc-network-dev (>= 2.6),
 libghc-network-prof,
 libghc-network-uri-dev (<< 2.7),
 libghc-network-uri-prof,
 libghc-pandoc-types-dev (>= 1.20),
 libghc-pandoc-types-dev (<< 1.21),
 libghc-pandoc-types-prof,
 libghc-random-dev (<< 1.2),
 libghc-random-prof,
 libghc-safe-dev (<< 0.4),
 libghc-safe-prof,
 libghc-scientific-dev (<< 0.4),
 libghc-scientific-prof,
 libghc-sha-dev (<< 1.7),
 libghc-sha-prof,
 libghc-skylighting-dev (>= 0.8.3.2),
 libghc-skylighting-dev (<< 0.9),
 libghc-skylighting-prof,
 libghc-skylighting-core-dev (>= 0.8.3.2),
 libghc-skylighting-core-dev (<< 0.9),
 libghc-skylighting-core-prof,
 libghc-split-dev (<< 0.3),
 libghc-split-prof,
 libghc-syb-dev (<< 0.8),
 libghc-syb-prof,
 libghc-tagsoup-dev (>= 0.14.6),
 libghc-tagsoup-dev (<< 0.15),
 libghc-tagsoup-prof,
 libghc-temporary-dev (<< 1.4),
 libghc-temporary-prof,
 libghc-texmath-dev (>= 0.12.0.1),
 libghc-texmath-dev (<< 0.13),
 libghc-texmath-prof,
 libghc-text-conversions-dev (<< 0.4),
 libghc-text-conversions-prof,
 libghc-unicode-transforms-dev (<< 0.4),
 libghc-unicode-transforms-prof,
 libghc-unordered-containers-dev (<< 0.3),
 libghc-unordered-containers-prof,
 libghc-vector-dev (<< 0.13),
 libghc-vector-prof,
 libghc-xml-dev (<< 1.4),
 libghc-xml-prof,
 libghc-zip-archive-dev (<< 0.5),
 libghc-zip-archive-prof,
 libghc-zlib-dev (<< 0.7),
 libghc-zlib-prof,
 libghc-diff-dev (<< 0.5),
 libghc-executable-path-dev (<< 0.1),
 libghc-quickcheck2-dev (<< 2.14),
 libghc-tasty-dev (>= 0.11),
 libghc-tasty-dev (<< 1.3),
 libghc-tasty-golden-dev (>= 2.3),
 libghc-tasty-golden-dev (<< 2.4),
 libghc-tasty-hunit-dev (<< 0.11),
 libghc-tasty-lua-dev (<< 0.3),
 libghc-tasty-quickcheck-dev (<< 0.11),
 haskell-devscripts,
 bash-completion
Build-Depends-Indep: ghc-doc,
 libghc-aeson-doc,
 libghc-aeson-pretty-doc,
 libghc-ansi-terminal-doc,
 libghc-asn1-encoding-doc,
 libghc-asn1-parse-doc,
 libghc-asn1-types-doc,
 libghc-async-doc,
 libghc-attoparsec-doc,
 libghc-base-compat-batteries-doc,
 libghc-base-compat-doc,
 libghc-base-orphans-doc,
 libghc-base16-bytestring-doc,
 libghc-base64-bytestring-doc,
 libghc-basement-doc,
 libghc-bitarray-doc,
 libghc-blaze-builder-doc,
 libghc-blaze-html-doc,
 libghc-blaze-markup-doc,
 libghc-case-insensitive-doc,
 libghc-cereal-doc,
 libghc-cmark-gfm-doc,
 libghc-colour-doc,
 libghc-connection-doc,
 libghc-cookie-doc,
 libghc-cryptonite-doc,
 libghc-data-default-class-doc,
 libghc-data-default-doc,
 libghc-data-default-instances-containers-doc,
 libghc-data-default-instances-dlist-doc,
 libghc-data-default-instances-old-locale-doc,
 libghc-digest-doc,
 libghc-dlist-doc,
 libghc-doclayout-doc,
 libghc-doctemplates-doc,
 libghc-emojis-doc,
 libghc-errors-doc,
 libghc-exceptions-doc,
 libghc-glob-doc,
 libghc-haddock-library-doc,
 libghc-hashable-doc,
 libghc-hourglass-doc,
 libghc-hslua-doc,
 libghc-hslua-module-text-doc,
 libghc-hslua-module-system-doc,
 libghc-hsyaml-doc,
 libghc-http-doc,
 libghc-http-client-doc,
 libghc-http-client-tls-doc,
 libghc-http-types-doc,
 libghc-hxt-charproperties-doc,
 libghc-hxt-doc,
 libghc-hxt-regex-xmlschema-doc,
 libghc-hxt-unicode-doc,
 libghc-integer-logarithms-doc,
 libghc-ipynb-doc,
 libghc-jira-wiki-markup-doc,
 libghc-juicypixels-doc,
 libghc-memory-doc,
 libghc-mime-types-doc,
 libghc-network-doc,
 libghc-network-uri-doc,
 libghc-old-locale-doc,
 libghc-pandoc-types-doc,
 libghc-pem-doc,
 libghc-primitive-doc,
 libghc-quickcheck2-doc,
 libghc-random-doc,
 libghc-regex-base-doc,
 libghc-regex-pcre-doc,
 libghc-safe-doc,
 libghc-scientific-doc,
 libghc-sha-doc,
 libghc-skylighting-core-doc,
 libghc-skylighting-doc,
 libghc-socks-doc,
 libghc-split-doc,
 libghc-splitmix-doc,
 libghc-streaming-commons-doc,
 libghc-syb-doc,
 libghc-tagged-doc,
 libghc-tagsoup-doc,
 libghc-temporary-doc,
 libghc-texmath-doc,
 libghc-text-conversions-doc,
 libghc-th-abstraction-doc,
 libghc-time-compat-doc,
 libghc-tls-doc,
 libghc-transformers-compat-doc,
 libghc-unicode-transforms-doc,
 libghc-unordered-containers-doc,
 libghc-utf8-string-doc,
 libghc-uuid-types-doc,
 libghc-vector-doc,
 libghc-x509-doc,
 libghc-x509-store-doc,
 libghc-x509-system-doc,
 libghc-x509-validation-doc,
 libghc-xml-doc,
 libghc-yaml-doc,
 libghc-zip-archive-doc,
 libghc-zlib-doc,
Standards-Version: 4.5.0
Homepage: https://pandoc.org/
Vcs-Git: https://salsa.debian.org/haskell-team/pandoc.git
Vcs-Browser: https://salsa.debian.org/haskell-team/pandoc
Rules-Requires-Root: no

Package: pandoc
Architecture: any
Depends: ${cdbs:Depends}
 , ${misc:Depends}
 , ${shlibs:Depends}
 , pandoc-data (>= ${source:Version})
 , pandoc-data (<< ${source:Version}.~)
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Provides:
 pandoc-abi (= ${pandoc:Abi}),
Multi-Arch: foreign
Description: general markup converter
 Pandoc is a Haskell library for converting
 from one markup format to another,
 and a command-line tool that uses this library.
 It can read several dialects of Markdown and (subsets of) HTML,
 reStructuredText, LaTeX, DocBook,
 JATS, MediaWiki markup, DokuWiki markup, TWiki markup, TikiWiki markup,
 Jira markup, Creole 1.0,
 Haddock markup, OPML, Emacs Org-mode, Emacs Muse,
 txt2tags, ipynb (Jupyter notebooks), Vimwiki,
 Word Docx, ODT, EPUB, FictionBook2,
 roff man, Textile, and CSV,
 and it can write Markdown, reStructuredText, XHTML, HTML 5,
 LaTeX (including rendering as plain PDF or beamer slide shows),
 ConTeXt, DocBook, JATS, OPML, TEI,
 OpenDocument, ODT, Word docx, PowerPoint pptx, RTF,
 MediaWiki, DokuWiki, XWiki, ZimWiki,
 Textile, Jira, roff man, roff ms, GNU Texinfo,
 plain text, Emacs Org-Mode, AsciiDoc, Haddock markup,
 EPUB (v2 and v3), ipynb, FictionBook2, InDesign ICML,
 Muse, LaTeX beamer slides, PowerPoint,
 and several kinds of HTML/javaScript slide shows
 (S5, Slidy, Slideous, DZSlides, reveal.js).
 .
 In contrast to most existing tools for converting Markdown to HTML,
 pandoc has a modular design:
 it consists of a set of readers, which parse text in a given format
 and produce a native representation of the document,
 and a set of writers,
 which convert this native representation into a target format.
 Thus,
 adding an input or output format requires only adding a reader or writer.
 .
 This package contains the pandoc tool.
 .
 Some uses of Pandoc require additional packages:
  * SVG content in PDF output requires librsvg2-bin.
  * YAML metadata in TeX-related output requires texlive-latex-extra.
  * *.hs filters not set executable requires ghc.
  * *.js filters not set executable requires nodejs.
  * *.php filters not set executable requires php.
  * *.pl filters not set executable requires perl.
  * *.py filters not set executable requires python.
  * *.rb filters not set executable requires ruby.
  * *.r filters not set executable requires r-base-core.
  * LaTeX output, and PDF output via PDFLaTeX,
    require texlive-latex-recommended.
  * XeLaTeX output, and PDF output via XeLaTeX, require texlive-xetex.
  * LuaTeX output, and PDF output via LuaTeX, require texlive-luatex.
  * ConTeXt output, and PDF output via ConTeXt, require context.
  * PDF output via wkhtmltopdf requires wkhtmltopdf.
  * Roff man and roff ms output, and PDF output via roff ms,
    require groff.
  * MathJax-rendered equations require libjs-mathjax.
  * KaTeX-rendered equations require node-katex.
  * option --csl may use styles in citation-style-language-styles.

Package: pandoc-data
Architecture: all
Depends: ${cdbs:Depends}
 , ${misc:Depends}
Recommends: ${cdbs:Recommends}
Suggests: ${cdbs:Suggests}
Multi-Arch: foreign
Description: general markup converter - data files
 Pandoc is a Haskell library for converting
 from one markup format to another,
 and a command-line tool that uses this library.
 It can read several dialects of Markdown and (subsets of) HTML,
 reStructuredText, LaTeX, DocBook,
 JATS, MediaWiki markup, DokuWiki markup, TWiki markup, TikiWiki markup,
 Jira markup, Creole 1.0,
 Haddock markup, OPML, Emacs Org-mode, Emacs Muse,
 txt2tags, ipynb (Jupyter notebooks), Vimwiki,
 Word Docx, ODT, EPUB, FictionBook2,
 roff man, Textile, and CSV,
 and it can write Markdown, reStructuredText, XHTML, HTML 5,
 LaTeX (including rendering as plain PDF or beamer slide shows),
 ConTeXt, DocBook, JATS, OPML, TEI,
 OpenDocument, ODT, Word docx, PowerPoint pptx, RTF,
 MediaWiki, DokuWiki, XWiki, ZimWiki,
 Textile, Jira, roff man, roff ms, GNU Texinfo,
 plain text, Emacs Org-Mode, AsciiDoc, Haddock markup,
 EPUB (v2 and v3), ipynb, FictionBook2, InDesign ICML,
 Muse, LaTeX beamer slides, PowerPoint,
 and several kinds of HTML/javaScript slide shows
 (S5, Slidy, Slideous, DZSlides, reveal.js).
 .
 In contrast to most existing tools for converting Markdown to HTML,
 pandoc has a modular design:
 it consists of a set of readers, which parse text in a given format
 and produce a native representation of the document,
 and a set of writers,
 which convert this native representation into a target format.
 Thus,
 adding an input or output format requires only adding a reader or writer.
 .
 This package contains the data files for pandoc.

Package: libghc-pandoc-dev
Section: haskell
Architecture: any
Depends: ${cdbs:Depends}
 , ${haskell:Depends}
 , ${haskell:Extra-Depends}
 , ${misc:Depends}
 , ${shlibs:Depends}
Recommends: ${haskell:Recommends}
Suggests: ${haskell:Suggests}
Provides: ${haskell:Provides}
Description: general markup converter - libraries
 Pandoc is a Haskell library for converting

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/hlibrary.mk

pkg = $(DEB_SOURCE_PACKAGE)

ABI = $(shell dpkg-query --showformat='$${source:Version}' --show libghc-pandoc-types-dev)

# helper macros for GHC dependencies, e.g.: foo bar,dev,prof doc,>=,1.2,<<,1.3 baz
expand-or-strip-ghc-dep = $(foreach expandsuffix,$1,\
 $(comma) libghc-$3-$(expandsuffix) $(if $4,($4 $5))\
 $(if $6,\
  $(comma) libghc-$3-$(expandsuffix) ($6 $7)))\
 $(foreach stripsuffix,$2,\
  $(comma) libghc-$3-$(stripsuffix))
expand-ghc-deps = $(foreach dep,$(sort $3),$(call expand-or-strip-ghc-dep,\
 $1,\
 $2,$(strip \
 $(word 1,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 2,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 3,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 4,$(subst $(comma),$(space),$(dep)))),$(strip \
 $(word 5,$(subst $(comma),$(space),$(dep))))))

# Haskell dependencies for any build from pandoc.cabal
ghc-deps += syb,<<,0.8
ghc-deps += unordered-containers,<<,0.3
ghc-deps += exceptions,>=,0.8,<<,0.11
ghc-deps += safe,<<,0.4
ghc-deps += zip-archive,<<,0.5
ghc-deps += http,<<,1:4000.4
ghc-deps += texmath,>=,0.12.0.1,<<,0.13
ghc-deps += xml,<<,1.4
ghc-deps += split,<<,0.3
ghc-deps += random,<<,1.2
ghc-deps += pandoc-types,>=,1.20,<<,1.21
ghc-deps += aeson,<<,1.5
ghc-deps += scientific,<<,0.4
ghc-deps += aeson-pretty,>=,0.8.5,<<,0.9
ghc-deps += tagsoup,>=,0.14.6,<<,0.15
ghc-deps += base64-bytestring,<<,1.1
ghc-deps += zlib,<<,0.7
ghc-deps += skylighting,>=,0.8.3.2,<<,0.9
ghc-deps += skylighting-core,>=,0.8.3.2,<<,0.9
ghc-deps += data-default,<<,0.8
ghc-deps += temporary,<<,1.4
ghc-deps += blaze-html,>=,0.9,<<,0.10
ghc-deps += blaze-markup,>=,0.8,<<,0.9
ghc-deps += vector,<<,0.13
ghc-deps += hslua,>=,1.0.1,<<,1.1
ghc-deps += jira-wiki-markup,>=,1.1,<<,1.2
ghc-deps += hslua-module-text,>=,0.2,<<,0.3
ghc-deps += hslua-module-system,>=,0.2,<<,0.3
ghc-deps += sha,<<,1.7
ghc-deps += haddock-library,>=,1.8,<<,1.9
ghc-deps += juicypixels,<<,3.4
ghc-deps += glob,<<,0.11
ghc-deps += cmark-gfm,>=,0.2,<<,0.3
ghc-deps += doctemplates,>=,0.8,<<,0.9
ghc-deps += network-uri,<<,2.7
ghc-deps += network,>=,2.6
ghc-deps += http-client,>=,0.4.30,,<<,0.7
ghc-deps += http-client-tls,>=,0.2.4,<<,0.4
ghc-deps += http-types,<<,0.13
ghc-deps += case-insensitive,>=,1.2,<<,1.3
ghc-deps += unicode-transforms,<<,0.4
ghc-deps += hsyaml,>=,0.2,<<,0.3
ghc-deps += doclayout,>=,0.3,<<,0.4
ghc-deps += ipynb,<<,0.2
ghc-deps += attoparsec,<<,0.14
ghc-deps += text-conversions,<<,0.4
ghc-deps += emojis,<<,0.2

# Haskell dependencies for testsuite from pandoc.cabal
ghc-deps-test += diff,<<,0.5
ghc-deps-test += tasty,>=,0.11,<<,1.3
ghc-deps-test += tasty-hunit,<<,0.11
ghc-deps-test += tasty-lua,<<,0.3
ghc-deps-test += tasty-quickcheck,<<,0.11
ghc-deps-test += tasty-golden,>=,2.3,<<,2.4
ghc-deps-test += quickcheck2,<<,2.14
ghc-deps-test += executable-path,<<,0.1

# Haskell dependencies (maybe) needed for documentation
# TODO: actually use these (not maintain Build-depends-indep by hand)
ghc-deps-doc += ansi-terminal
ghc-deps-doc += asn1-encoding
ghc-deps-doc += asn1-parse
ghc-deps-doc += asn1-types
ghc-deps-doc += async
ghc-deps-doc += base16-bytestring
ghc-deps-doc += base-compat
ghc-deps-doc += base-compat-batteries
ghc-deps-doc += basement
ghc-deps-doc += base-orphans
ghc-deps-doc += bitarray
ghc-deps-doc += blaze-builder
ghc-deps-doc += cereal
ghc-deps-doc += colour
ghc-deps-doc += connection
ghc-deps-doc += cookie
ghc-deps-doc += cryptonite
ghc-deps-doc += data-default-class
ghc-deps-doc += data-default-instances-containers
ghc-deps-doc += data-default-instances-dlist
ghc-deps-doc += data-default-instances-old-locale
ghc-deps-doc += digest
ghc-deps-doc += dlist
ghc-deps-doc += errors
ghc-deps-doc += hashable
ghc-deps-doc += hourglass
ghc-deps-doc += hs-bibutils
ghc-deps-doc += hsyaml
ghc-deps-doc += hxt
ghc-deps-doc += hxt-charproperties
ghc-deps-doc += hxt-regex-xmlschema
ghc-deps-doc += hxt-unicode
ghc-deps-doc += integer-logarithms
ghc-deps-doc += memory
ghc-deps-doc += mime-types
ghc-deps-doc += old-locale
ghc-deps-doc += pcre-light
ghc-deps-doc += pem
ghc-deps-doc += primitive
ghc-deps-doc += quickcheck2
ghc-deps-doc += regex-base
ghc-deps-doc += regex-pcre
ghc-deps-doc += rts
ghc-deps-doc += socks
ghc-deps-doc += splitmix
ghc-deps-doc += streaming-commons
ghc-deps-doc += tagged
ghc-deps-doc += th-abstraction
ghc-deps-doc += time-compat
ghc-deps-doc += tls
ghc-deps-doc += transformers
ghc-deps-doc += transformers-compat
ghc-deps-doc += unicode-transforms
ghc-deps-doc += utf8-string
ghc-deps-doc += uuid-types
ghc-deps-doc += x509
ghc-deps-doc += x509-store
ghc-deps-doc += x509-system
ghc-deps-doc += x509-validation

# Needed by upstream build process
CDBS_BUILD_DEPENDS +=, ghc, ghc-prof, alex, happy
CDBS_BUILD_DEPENDS += $(call expand-ghc-deps,dev,prof,$(ghc-deps))
CDBS_BUILD_DEPENDS += $(call expand-ghc-deps,dev,,$(ghc-deps-test))
CDBS_BUILD_DEPENDS_INDEP +=, ghc-doc
CDBS_BUILD_DEPENDS_INDEP +=, $(call expand-ghc-deps,,doc,$(ghc-deps) $(ghc-deps-doc))

# Needed for our packaging
#  * recent haskell-devscripts needed for version-less datadir
CDBS_BUILD_DEPENDS +=, haskell-devscripts

# Needed (always/often/seldom) at runtime
#  texlive-* needed for PDF output
#  librsvg2-bin (rsvg-convert) needed for SVG in PDF output
#  groff needed for groff man and groff ms output
# TODO: suggest slide show Javascript libraries when in Debian
CDBS_SUGGESTS_$(pkg) = texlive-latex-recommended, texlive-xetex, texlive-luatex
CDBS_SUGGESTS_$(pkg) +=, pandoc-citeproc, texlive-latex-extra, context
CDBS_SUGGESTS_$(pkg) +=, wkhtmltopdf, librsvg2-bin, groff, ghc, nodejs
CDBS_SUGGESTS_$(pkg) +=, php, perl, python, ruby, r-base-core
CDBS_SUGGESTS_$(pkg) +=, libjs-mathjax, libjs-katex
CDBS_SUGGESTS_$(pkg) +=, citation-style-language-styles

# Fix exception thrown building documentation:
# haddock: internal error: <stdout>: commitBuffer: invalid argument (invalid character)
export LANG=C.UTF-8

# Use threaded RTS only when supported
DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(wildcard /usr/lib/ghc-$(GHC_VERSION)/libHSrts_thr.a),,--flags=-threaded)

# Disable timer to help build on slow arches like hppa
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="+RTS -V0 -RTS"

# Reduce compile-time memory utilization on low-memory architectures
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf arm64 hppa mips mipsel riscv64))
DEB_SETUP_GHC_CONFIGURE_ARGS += --ghc-options="-optc--param -optcggc-min-expand=10 -O0"
endif

DEB_ENABLE_TESTS = yes
DEB_SETUP_GHC_CONFIGURE_ARGS += $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-ftests)

DEB_INSTALL_DOCS_ALL += README.md

DEB_INSTALL_MANPAGES_$(pkg) = man/pandoc.1

CDBS_BUILD_DEPENDS +=, bash-completion
post-install/$(pkg)::
	debian/tmp-inst-*/usr/bin/pandoc --bash-completion \
		> debian/pandoc.bash-completion
binary-install/$(pkg)::
	dh_bash-completion
clean::
	rm -f debian/pandoc.bash-completion

DEB_DH_GENCONTROL_ARGS_$(pkg) = -- -V"pandoc:Abi=$(ABI)"
